using Microsoft.Office.InfoPath;
using System;
using System.Windows.Forms;
using System.Xml;
using System.Xml.XPath;

namespace template14
{
    public partial class FormCode
    {
        public void InternalStartup()
        {
            EventManager.XmlEvents["/my:myFields/my:field1"].Changing += new XmlChangingEventHandler(field1_Changing);
            EventManager.XmlEvents["/my:myFields/my:field1"].Validating += new XmlValidatingEventHandler(field1_Validating);
            EventManager.XmlEvents["/my:myFields/my:field1"].Changed += new XmlChangedEventHandler(field1_Changed);
        }

        public void field1_Changing(object sender, XmlChangingEventArgs e)
        {
            // Ensure that the constraint you are enforcing is compatible
            // with the default value you set for this XML node.
            MessageBox.Show("Changing");
        }

        public void field1_Validating(object sender, XmlValidatingEventArgs e)
        {
            MessageBox.Show("Validating");
        }

        public void field1_Changed(object sender, XmlEventArgs e)
        {
            // Write code here to change data outside the Main Data Object
            // such as other Data Objects and member variables.

            if (e.UndoRedo)
            {
                // InfoPath will handle all undo and redo operations that change
                // the Main Data Object, so nothing left for custom to do.
                return;
            }

            MessageBox.Show("Changed");
        }
    }
}
