using System;
using System.Collections.Specialized;
using System.Runtime.InteropServices;
using System.Xml.XPath;

namespace HostClassLibrary
{
    public interface IHostUtilities
    {
        bool IsValidEstimate(XPathNavigator navigator, out string errorMessage);
    }

    [ComVisible(true)]
    [Serializable]
    public class HostUtilities : IHostUtilities
    {
        public bool IsValidEstimate(XPathNavigator node, out string errorMessage)
        {
            bool isValid = true;

            errorMessage = null;

            if (node != null && node.NodeType == XPathNodeType.Element && node.Value != "")
            {
                try
                {
                    double estimate = node.ValueAsDouble;

                    if (estimate <= 0)
                    {
                        errorMessage = "The estimate must be greater than 0";
                        isValid = false;
                    }
                    else if (estimate > 10000)
                    {
                        errorMessage = "The estimate is too high. Ensure that the estimate is correct.";
                        isValid = false;
                    }
                }
                catch (FormatException)
                {
                }
            }

            return isValid;
        }
    }
}
