using System;
using System.Collections.Generic;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[WebService(Namespace = "http://MoiConsultingRequest/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    public Service()
    {
    }

    public enum RequestType
    {
        AccountQuestion,
        ConsultantRequest,
        SensitiveCritical,
        Other
    }

    [WebMethod]
    public string[] GetSubAreas(RequestType requestType)
    {
        List<string> results = new List<string>();
        switch (requestType)
        {
            case RequestType.AccountQuestion:
                results.Add("Set up auto bill pay");
                results.Add("How to pay");
                results.Add("Schedule a payment");
                results.Add("Balance outstanding");
                results.Add("Late dues");
                results.Add("Change of address");
                results.Add("Chose account");
                results.Add("Other");
                break;
            case RequestType.ConsultantRequest:
                results.Add("Who is my consultant?");
                results.Add("Research");
                results.Add("Opinion");
                results.Add("References");
                results.Add("On-site training");
                results.Add("Setup / installation");
                results.Add("Feedback");
                results.Add("Other");
                break;
            case RequestType.SensitiveCritical:
                results.Add("Critical system failure");
                results.Add("Large investment at risk");
                results.Add("Insurance claims");
                results.Add("Immediate action necessary");
                results.Add("Other");
                break;
            case RequestType.Other:
                results.Add("(Please fill in the above 'Other' field.)");
                break;
            default:
                throw new NotSupportedException("This request type is not supported: " + requestType);
        }
        return results.ToArray();
    }

}
