// InfoPathChartControl.cpp : Implementation of InfoPathChartControl
#include "stdafx.h"
#include "InfoPathChartControl.h"

// InfoPathChartControl

STDMETHODIMP InfoPathChartControl::get_Value(IDispatch** ppdispValue)
{
    return S_OK;
}

STDMETHODIMP InfoPathChartControl::put_Value(IDispatch* pdispValue)
{
    HRESULT hr;
    CComPtr<IXMLDOMNode>    spGroupNode;

    m_rgSweepAngles.RemoveAll();

    hr = pdispValue->QueryInterface(IID_IXMLDOMNode, (void**)&spGroupNode);
    if (SUCCEEDED(hr))
    {
        CComPtr<IXMLDOMNodeList>    spChildNodes;

        hr = spGroupNode->get_childNodes(&spChildNodes);
        if (SUCCEEDED(hr))
        {
            long cChildren;

            hr = spChildNodes->get_length(&cChildren);
            if (SUCCEEDED(hr))
            {
                CSimpleArray<double> m_rgValues;

                for (long i = 0; i < cChildren; i++)
                {
                    CComPtr<IXMLDOMNode> spChild;

                    spChildNodes->get_item(i, &spChild);
                    if (spChild != NULL)
                    {
                        DOMNodeType nodeType;

                        hr = spChild->get_nodeType(&nodeType);
                        if (SUCCEEDED(hr) && nodeType == NODE_ELEMENT)
                        {
                            CComBSTR bstrValue;

                            hr = spChild->get_text(&bstrValue);
                            if (SUCCEEDED(hr))
                            {
                                double dValue = wcstod(bstrValue, NULL);

                                m_rgValues.Add(dValue);
                            }
                        }
                    }
                }

                double dTotal = 0;
                long cValues = m_rgValues.GetSize();

                for (long i = 0; i < cValues; i++)
                {
                    dTotal += m_rgValues[i];
                }

                if (dTotal != 0)
                {
                    for (long i = 0; i < cValues; i++)
                    {
                        REAL sweepAngle = 360.0 * (m_rgValues[i] / dTotal);
                        m_rgSweepAngles.Add(sweepAngle);
                    }
                }
            }
        }
    }

    return S_OK;
}

// InfoPathControl
STDMETHODIMP InfoPathChartControl::Init(InfoPathControlSite* pControlSite)
{
    return pControlSite->QueryInterface(__uuidof(InfoPathControlSite), (void**)&m_spControlSite);
}

STDMETHODIMP InfoPathChartControl::Uninit()
{
    m_spControlSite = NULL;
    return S_OK;
}

STDMETHODIMP InfoPathChartControl::SaveState()
{
    // Save any state information that you
    // want to persist across view reapply
    // (e.g., height, width, etc.
    return S_OK;
}

STDMETHODIMP InfoPathChartControl::Enable(VARIANT_BOOL vfEnabled)
{
    if (IsWindow())
    {
        EnableWindow(vfEnabled);
    }

    return S_OK;
}
