// SimpleInfoPathControl.cpp : Implementation of SimpleInfoPathControl
#include "stdafx.h"
#include "SimpleInfoPathControl.h"


// SimpleInfoPathControl

STDMETHODIMP_(void) SimpleInfoPathControl::OnBackColorChanged()
{
	ATLTRACE(_T("OnBackColorChanged\n"));
}

STDMETHODIMP_(void) SimpleInfoPathControl::OnEnabledChanged()
{
	ATLTRACE(_T("OnEnabledChanged\n"));
}

STDMETHODIMP SimpleInfoPathControl::get_Value(BSTR* pVal)
{
    HRESULT hr = S_OK;

    if (pVal == NULL)
    {
        hr = E_INVALIDARG;
    }
    else if (m_ctlRichEdit.IsWindow())
    {
        CComBSTR bstrValue;

        m_ctlRichEdit.GetWindowTextW(&m_bstrValue);
        hr = m_bstrValue.CopyTo(pVal);
    }
    
    return hr;
}

STDMETHODIMP SimpleInfoPathControl::put_Value(BSTR newVal)
{
    m_bstrValue = newVal;  // Save the current value in a data member

    if (m_ctlRichEdit.IsWindow())  // Has the control been created?
    {
        // Set the value of the Rich Edit control to the new value.
        m_ctlRichEdit.SetWindowTextW(newVal);
    }

    return S_OK;
}

// InfoPathControl
STDMETHODIMP SimpleInfoPathControl::Init(InfoPathControlSite* pControlSite)
{
    return pControlSite->QueryInterface(__uuidof(InfoPathControlSite), (void**)&m_spControlSite);
}

STDMETHODIMP SimpleInfoPathControl::Uninit()
{
    m_spControlSite = NULL;
    return S_OK;
}

STDMETHODIMP SimpleInfoPathControl::SaveState()
{
    // Save any state information that you
    // want to persist across view reapply
    // (e.g., height, width, etc.)
    return S_OK;
}

STDMETHODIMP SimpleInfoPathControl::Enable(VARIANT_BOOL vfEnabled)
{
    if (m_ctlRichEdit.IsWindow())
    {
        m_ctlRichEdit.EnableWindow(vfEnabled);
    }

    return S_OK;
}
