// FormDataTPActiveXCtl.h : Declaration of the CFormDataTPActiveXCtl
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include <gdiplus.h>

#import "C:\Program Files\Microsoft Office\Office12\ipeditor.dll" raw_interfaces_only no_namespace
#import "C:\Program Files\Common Files\Microsoft Shared\OFFICE12\mso.dll" raw_interfaces_only no_namespace exclude("Signature", "UserPermission", "Permission", "IAccessible", "DocumentProperties")
#import "..\FormDataTaskPane\bin\FormDataTaskPane.tlb" raw_interfaces_only no_namespace

using namespace Gdiplus;

// IFormDataTPActiveXCtl
[
	object,
	uuid(CABEAD2D-2E31-4507-8299-90CBA2C924D7),
	dual,
	helpstring("IFormDataTPActiveXCtl Interface"),
	pointer_default(unique)
]
__interface IFormDataTPActiveXCtl : public IDispatch
{
    [propput, id(1), helpstring("Application property")] HRESULT Application([in] IDispatch* pApplication);
};


// CFormDataTPActiveXCtl
[
	coclass,
	control,
	default(IFormDataTPActiveXCtl),
	threading(apartment),
	vi_progid("FormDataTaskPaneActiveX.FormDataTPAxCtl"),
	progid("FormDataTaskPaneActiveX.FormDataTPAxC.1"),
	version(1.0),
	uuid("0637AA01-F534-4F1C-9582-82FCF1A8410F"),
	helpstring("FormDataTPActiveXCtl Class"),
	support_error_info(IFormDataTPActiveXCtl),
	registration_script("control.rgs")
]
class ATL_NO_VTABLE CFormDataTPActiveXCtl :
	public IFormDataTPActiveXCtl,
	public IPersistStreamInitImpl<CFormDataTPActiveXCtl>,
	public IOleControlImpl<CFormDataTPActiveXCtl>,
	public IOleObjectImpl<CFormDataTPActiveXCtl>,
	public IOleInPlaceActiveObjectImpl<CFormDataTPActiveXCtl>,
	public IViewObjectExImpl<CFormDataTPActiveXCtl>,
	public IOleInPlaceObjectWindowlessImpl<CFormDataTPActiveXCtl>,
	public IObjectWithSiteImpl<CFormDataTPActiveXCtl>,
	public IPersistStorageImpl<CFormDataTPActiveXCtl>,
	public ISpecifyPropertyPagesImpl<CFormDataTPActiveXCtl>,
	public IQuickActivateImpl<CFormDataTPActiveXCtl>,
	public IDataObjectImpl<CFormDataTPActiveXCtl>,
	public IProvideClassInfo2Impl<&__uuidof(CFormDataTPActiveXCtl), NULL>,
	public IObjectSafetyImpl<CFormDataTPActiveXCtl, INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA>,
	public CComControl<CFormDataTPActiveXCtl>
{
public:
    CFormDataTPActiveXCtl()
	{
        // Initialize GDI+
        GdiplusStartupInput gdiplusStartupInput;

        GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);
	}

    ~CFormDataTPActiveXCtl()
    {
        GdiplusShutdown(m_gdiplusToken);
    }

    DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
	    OLEMISC_CANTLINKINSIDE |
	    OLEMISC_INSIDEOUT |
	    OLEMISC_ACTIVATEWHENVISIBLE |
	    OLEMISC_SETCLIENTSITEFIRST)

    BEGIN_PROP_MAP(CFormDataTPActiveXCtl)
	    PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	    PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	    // Example entries
	    // PROP_ENTRY("Property Description", dispid, clsid)
	    // PROP_PAGE(CLSID_StockColorPage)
    END_PROP_MAP()


    BEGIN_MSG_MAP(CFormDataTPActiveXCtl)
	    CHAIN_MSG_MAP(CComControl<CFormDataTPActiveXCtl>)
	    DEFAULT_REFLECTION_HANDLER()
    END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IFormDataTPActiveXCtl
    HRESULT OnDraw(ATL_DRAWINFO& di)
    {
        RECT& rc = *(RECT*)di.prcBounds;

        // Set Clip region to the rectangle specified by di.prcBounds
        HRGN hRgnOld = NULL;

        if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
	        hRgnOld = NULL;

        bool bSelectOldRgn = false;

        HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);

        if (hRgnNew != NULL)
        {
	        bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
        }

        Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
        SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);

        if (_bstrXML.Length() == 0)
        {
            _bstrXML = L"The document is empty.";
        }

        Gdiplus::Font font(L"Verdana", 10);
		Graphics graphics(di.hdcDraw); 
        PointF pt(10.0, 10.0);
        SolidBrush brush(Color::Black);

        StringFormat format;

        graphics.DrawString(_bstrXML, _bstrXML.Length(), &font, pt, &brush);

        if (bSelectOldRgn)
        {
	        SelectClipRgn(di.hdcDraw, hRgnOld);
        }

        return S_OK;
    }

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}

	void FinalRelease()
	{
	}

    // IFormDataTPActiveXCtl
    STDMETHOD(put_Application)(IDispatch* pApplication);

private:
    _ApplicationPtr _spApplication;
    CComBSTR  _bstrXML;
    ULONG_PTR m_gdiplusToken;

    void FireTaskPaneReady();
    void FormatXml(IXMLDOMNode* pNode, BSTR* pbstrXML, int level);
    void OutputAttributes(IXMLDOMNode* pParent, CComBSTR& bstrXML, int level);
};

